
#include <stdio.h>
#include <stdint.h>
#include <stddef.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <limits.h>
#include "pwm.h"

static void crash(const char* msg) {
  perror(msg);
  __builtin_trap();
}

static void setStdInput(const uint8_t *data, size_t size) {
  char tmpfile[PATH_MAX+1];
  FILE* fp = NULL;
  if (   tmpnam(tmpfile) == 0 
      || (fp = fopen(tmpfile, "w+")) == NULL
      || fwrite(data, 1, size, fp) != size
      || fclose(fp) != 0
      || freopen(tmpfile, "r", stdin) == NULL
      || unlink(tmpfile) != 0) {
    crash("Unable to create / setup temporary file: ");
  }
}

int LLVMFuzzerTestOneInput(const uint8_t *data, size_t size) {
  setStdInput(data, size);
  pwm_interactive_session();
  return 0;
}
